@echo off
title Generic PS1 multi-track image patcher/rebuilder v0.4 - Breath of Fire IV Edition
:: The "patcher" utilises mkpsxiso https://github.com/Lameguy64/mkpsxiso
:: binmerge https://github.com/putnam/binmerge
:: Xdelta https://github.com/jmacd/xdelta-gpl
:: and FART https://sourceforge.net/projects/fart-it

:: An attempt at fool-proofing the thing
echo Before continuing, place a CUE+BINs image into the patcher's directory
echo (where this batch file is located) if you haven't already.
echo.
echo IMPORTANT: There must be no other .CUE or .BIN files present within
echo the patcher's directory besides the ones belonging to the input image.
echo You have been warned.
echo.
pause

echo Relocating the input image...
move *.cue "tools/Breath of Fire IV.cue"
move *.bin tools
cd tools

echo Merging the tracks...
binmerge "Breath of Fire IV.cue" merged

echo Dumping the merged image...
dumpsxiso "merged.bin" -x Extracted -s map.xml

echo Applying xdelta patches...
ren Extracted\BIN\XA\ZBOF4.STR ZBOF4.OG
xdelta -d -n -s Extracted\BIN\XA\ZBOF4.OG ZBOF4.xdelta Extracted\BIN\XA\ZBOF4.STR
del Extracted\BIN\XA\ZBOF4.OG

:: echo Merging the modded data...
:: robocopy MOD Extracted /IS /E

echo Setting the output names...
fart map.xml "mkpsxiso.bin" "Breath of Fire IV patched.bin"
fart map.xml "mkpsxiso.cue" "Breath of Fire IV patched.cue"

echo Building a new image...
mkpsxiso map.xml

:: BoF4-specific
echo Adding a footer for compatibility reasons...
copy /b "Breath of Fire IV patched.bin"+footer.dat "Breath of Fire IV patched.bin"

echo Moving the stuff out...
move "Breath of Fire IV patched.bin" ..
move "Breath of Fire IV patched.cue" ..
del merged.bin
del merged.cue
move *.cue ..
move *.bin ..

echo Cleaning up...
rmdir /Q /S Extracted
del map.xml
cd ..

echo.
echo All done!
pause